#include <string>
#include <iostream>

#include "htmlParser.h"

void StartElement(void* voidContext, const xmlChar* name, const xmlChar** attr) {
  Context* myContext = (Context*) voidContext; 
 
  if (!strcasecmp((char*)name, "title")) {
    myContext->title = "";
    myContext->titleTag = true;
  }
}

void EndElement(void* voidContext, const xmlChar* name) { 
  Context* myContext = (Context*) voidContext; 
  
  if (!strcasecmp((char*)name, "title")) {
    myContext->titleTag = false;
  }
}

void Characters(void* voidContext, const xmlChar* chars, int len) {
  Context* myContext = (Context*) voidContext; 

  if (myContext->titleTag) {
    myContext->title.append((char*)chars, len);
  }
}

htmlSAXHandler saxHandler = {
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  StartElement,
  EndElement,
  nullptr,
  Characters,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr
};

std::string parseHTML(const std::string& html) {
  htmlParserCtxtPtr ctxt;
  Context context;

  ctxt = htmlCreatePushParserCtxt(&saxHandler, &context, "", 0, "", XML_CHAR_ENCODING_NONE);

  htmlParseChunk(ctxt, html.c_str(), html.size(), 0);
  htmlParseChunk(ctxt, "", 0, 1);

  htmlFreeParserCtxt(ctxt);

  return context.title;
}
